﻿// --------------------------------------------------------------------------------------
//
// Bearbeitungsstation3                                            Ulrich Müller 31.10.08
//                                                                 Aspire C# 2005 Express
// Kasten PneuVac : Bearbeitungsstation mit Farberkennung frei nach Seite 10 Bgleitheft
// Mit FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace Bearbeitungsstation3 {
  public partial class frmMain : Form {
    FishFace ft = new FishFace();
    const Out motKompressor     = Out.M1;
    const Out motTransportBand  = Out.M2;
    const Out venSchieber       = Out.O5;
    const Out venAuswerfer      = Out.O6;
    const Out venStanze         = Out.O7;
    const Out lamLichtschranken = Out.O8;
    const Inp phoStapel         = Inp.I1;
    const Inp phoStanze         = Inp.I2;
    const Inp volFarbe          = Inp.A1;
    const int cWeiss            = 240;

    private void Action() {
      int FarbWert;
      // --- Starten der Anlage ---
      ft.SetMotor(motKompressor, Dir.Links);
      ft.SetLamp(lamLichtschranken, Dir.Ein);
      ft.Pause(3000);
      do {
        // --- Teil aus Magazin auf Band ---
        ft.WaitForInput(phoStapel, false);
        ft.SetLamp(venSchieber, Dir.Ein);
        ft.Pause(100);
        ft.SetLamp(venSchieber, Dir.Aus);
        ft.Pause(100);
        ft.SetMotor(motTransportBand, Dir.Links);
        FarbWert = ft.GetVoltage(volFarbe);
        lblFarbe.Text = "Farbwert : " + FarbWert.ToString();
        if (FarbWert <= cWeiss) {
          // --- weiße Teile bearbeiten ---
          ft.WaitForLow(phoStanze);
          ft.SetMotor(motTransportBand, Dir.Aus);
          ft.SetLamp(venStanze, Dir.Ein);
          ft.Pause(1000);
          ft.SetLamp(venStanze, Dir.Aus);
        }
        else {
          // --- Fehlteile auswerfen ---
          ft.SetLamp(venAuswerfer, Dir.Ein);
          ft.Pause(5000);
          ft.SetLamp(venAuswerfer, Dir.Aus);
          ft.SetMotor(motTransportBand, Dir.Aus);
        }
      } while (!ft.Finish());
      // --- Teile auslaufen lassen ---
      ft.NotHalt = false;
      ft.SetMotor(motTransportBand, Dir.Links);
      ft.Pause(5000);
    }

    #region --- Programm-Kontrolle ---
    public frmMain() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      // --- Open erstes ROBO an USB oder Intelligent Interface an COM
      //     während des Ablaufs von Action() gesperrt ---------------
      try {
        if (cboPortName.SelectedIndex == 0)
          ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        else ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

        ft.ClearMotors();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        ft.CloseInterface();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
    }

    private void formLoad(object sender, EventArgs e) {
      // --- Default-Interface : Erstes ROBO Interface an USB ----
      cboPortName.SelectedIndex = 0;
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}