﻿' -----------------------------------------------------------------------------------------
'
' KartenGeber4VB                                                    Ulrich Müller  05.11.08
'                                                                   Aspire  VB 2005 Express
' PneuVac : Austeilen der Karten für eine Spielrunde mit drei Spielern
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class frmMain

	Dim ft As New FishFace()
	Const motKompressor = Out.M1
	Const motDrehArm = Out.M2
	Const venArm = Out.O5
	Const venGreifer = Out.O6
	Const venVacuum = Out.O7
	Const lamLichtschranken = Out.O8
	Const phoDrehEnde = Inp.I1
	Const phoKarte = Inp.I2
	Const farKarte = Inp.A1
	Dim Farbe As Integer = 270
	Dim pauseMSek As Integer

	Private Sub Kompressor()
		ft.SetMotor(motKompressor, Dir.Rechts)
		prgDruck.Value = 0
		prgDruck.Visible = True
		For t As Integer = 1 To 120
			ft.Pause(100)
			prgDruck.Value = t * 100
		Next
		prgDruck.Visible = False
		ft.SetMotor(motKompressor, Dir.Aus)
	End Sub
	Private Sub AufnahmePos()
		ft.SetLamp(lamLichtschranken, Dir.Ein)
		ft.Pause(pauseMSek)
		If ft.GetInput(phoDrehEnde) Then
			ft.SetMotor(motDrehArm, Dir.Links)
			ft.WaitForInput(phoDrehEnde, False)
			ft.SetMotor(motDrehArm, Dir.Aus)
			ft.Pause(pauseMSek)
		End If
		ft.SetLamp(lamLichtschranken, Dir.Aus)
	End Sub
	Private Sub KarteAufnehmen()
		Dim farbWert As Integer
		Do
			ft.SetLamp(lamLichtschranken, Dir.Ein)
			ft.Pause(pauseMSek)
			ft.WaitForInput(phoKarte, False)
			ft.SetLamp(lamLichtschranken, Dir.Aus)
			ft.SetMotor(motKompressor, Dir.Rechts)
			ft.Pause(2000)
			ft.SetLamp(venGreifer, Dir.Ein)
			ft.Pause(pauseMSek)
			ft.SetLamp(venVacuum, Dir.Ein)
			ft.Pause(pauseMSek)
			ft.SetLamp(venGreifer, Dir.Aus)
			ft.Pause(3000)
			ft.SetLamp(venArm, Dir.Ein)
			ft.SetMotor(motKompressor, Dir.Aus)
			ft.Pause(pauseMSek)
			For z As Integer = 1 To 10
				farbWert = ft.GetVoltage(farKarte)
				lblFarbe.Text = "Farbwert : " & farbWert.ToString()
				If farbWert >= Farbe Then
					ft.SetLamp(venArm, Dir.Aus)
					ft.Pause(pauseMSek)
					Return
				End If
				ft.Pause(100)
			Next z
			ft.SetLamp(venArm, Dir.Aus)
			ft.Pause(pauseMSek)
			ft.SetLamp(venGreifer, Dir.Ein)
			ft.Pause(pauseMSek)
			ft.SetLamp(venVacuum, Dir.Aus)
			ft.Pause(pauseMSek)
			ft.SetLamp(venGreifer, Dir.Aus)
		Loop Until ft.Finish()
	End Sub
	Private Sub KarteAblegen()
		ft.SetLamp(venGreifer, Dir.Ein)
		ft.Pause(pauseMSek)
		ft.SetLamp(venVacuum, Dir.Aus)
		ft.Pause(pauseMSek)
		ft.SetLamp(venGreifer, Dir.Aus)
		ft.Pause(pauseMSek)
	End Sub
	Private Sub KarteGeben(ByVal Position As Integer)
		AufnahmePos()
		KarteAufnehmen()
		ft.SetMotor(motDrehArm, Dir.Rechts)
		ft.Pause(Position)
		ft.SetMotor(motDrehArm, Dir.Aus)
		ft.Pause(pauseMSek)
		ft.SetMotor(motKompressor, Dir.Links)
		KarteAblegen()
		ft.SetMotor(motKompressor, Dir.Aus)
	End Sub
	Private Sub Action()
		lblStatus.Text = "Kompressor : Druckaufbau"
		Kompressor()
		pauseMSek = numPause.Value
		Farbe = numFarbe.Value

		For z As Integer = 1 To 3
			lblStatus.Text = "Runde " & z.ToString() & " : Karte für 600"
			KarteGeben(600)
			lblStatus.Text = "Runde " & z.ToString() & " : Karte für 1300"
			KarteGeben(1300)
			lblStatus.Text = "Runde " & z.ToString() & " : Karte für den Dritten"
			KarteGeben(2000)
		Next
		AufnahmePos()
	End Sub

#Region "--- ProgramControl ---"
	Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
	Handles cmdAction.Click
		' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
		'     während des Ablaufs von Action gesperrt
		Try
			If cboPortName.SelectedIndex = 0 Then
				ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
			Else
				ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
			End If
			cmdAction.Enabled = False
			cmdEnde.Text = "&HALT"
			lblStatus.Text = "--- Bei der Arbeit ---"

			Action()					' --- Nutz-Routine für die Anwendung

			ft.ClearMotors()
		Catch ex As FishFaceException
			MsgBox(ex.Message)
		Finally
			ft.CloseInterface()
			cmdAction.Enabled = True
			cmdEnde.Text = "&ENDE"
			lblStatus.Text = "--- Auf ein Neues ---"
			cmdEnde.Focus()
		End Try

	End Sub

	Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
		' --- Programmende nur, wenn Action nicht läuft ---
		If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
	End Sub

	Private Sub frmLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		' --- Default erstes ROBO Interface an USB ---
		cboPortName.SelectedIndex = 0
	End Sub

	Private Sub frmClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
		' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
		If cmdEnde.Text = "&HALT" Then e.Cancel = True
	End Sub

#End Region

End Class
