﻿// --------------------------------------------------------------------------------------
//
// VakuumGreifer2                                                  Ulrich Müller 02.11.08
//                                                                 Aspire C# 2005 Express
// PneuVac Magazin : Vereinzelung
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace VakuumGreifer2 {
  public partial class frmMain : Form {
    FishFace ft = new FishFace();
    const Out motKompressor     = Out.M1;
    const Out motDrehArm        = Out.M2;
    const Out venSchieber       = Out.O5;
    const Out venGreifer        = Out.O6;
    const Out venVacuum         = Out.O7;
    const Out lamLichtschranken = Out.O8;
    const Inp phoDrehEnde       = Inp.I1;
    const Inp phoMagazin        = Inp.I2;

    private void Kompressor() {
      ft.SetMotor(motKompressor, Dir.Rechts);
      ft.Pause(12000);
      ft.SetMotor(motKompressor, Dir.Aus);
    }

    private void Action() {
      lblStatus.Text = "Kompressor : Druckaufbau";
      Kompressor();
      ft.SetLamp(lamLichtschranken, Dir.Ein);
      ft.Pause(1000);

      lblStatus.Text = "Vereinzeln, wenn Teil da";
      ft.WaitForInput(phoMagazin, false);
      ft.SetLamp(lamLichtschranken, Dir.Aus);
      ft.SetLamp(venSchieber, Dir.Ein);
      ft.Pause(1000);
      ft.SetLamp(venSchieber, Dir.Aus);
      ft.Pause(1000);
    }

    #region --- Programm-Kontrolle ---
    public frmMain() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      // --- Open erstes ROBO an USB oder Intelligent Interface an COM
      //     während des Ablaufs von Action() gesperrt ---------------
      try {
        if (cboPortName.SelectedIndex == 0)
          ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        else ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

        ft.ClearMotors();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        ft.CloseInterface();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
    }

    private void formLoad(object sender, EventArgs e) {
      // --- Default-Interface : Erstes ROBO Interface an USB ----
      cboPortName.SelectedIndex = 0;
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}