﻿// --------------------------------------------------------------------------------------
//
// VakuumGreifer4                                                  Ulrich Müller 02.11.08
//                                                                 Aspire C# 2005 Express
// PneuVac : Betriebsprogramm für den Vakuumgreifer
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace VakuumGreifer4 {
  public partial class frmMain : Form {
    FishFace ft = new FishFace();
    const Out motKompressor     = Out.M1;
    const Out motDrehArm        = Out.M2;
    const Out venSchieber       = Out.O5;
    const Out venGreifer        = Out.O6;
    const Out venVacuum         = Out.O7;
    const Out lamLichtschranken = Out.O8;
    const Inp phoDrehEnde       = Inp.I1;
    const Inp phoMagazin        = Inp.I2;
    
    int cPauseSek;

    private void Kompressor() {
      ft.SetMotor(motKompressor, Dir.Rechts);
      ft.Pause(12000);
      ft.SetMotor(motKompressor, Dir.Aus);
    }

    private void Action() {
      lblStatus.Text = "Kompressor : Druckaufbau";
      Kompressor();
      cPauseSek = (int)numPause.Value;
      do {
        ft.SetLamp(lamLichtschranken, Dir.Ein);
        ft.Pause(cPauseSek);
        if (ft.GetInput(phoDrehEnde)) {
          lblStatus.Text = "Zur Position am Magazin";
          ft.SetMotor(motDrehArm, Dir.Links);
          ft.WaitForInput(phoDrehEnde, false);
          ft.Pause(20);
          ft.SetMotor(motDrehArm, Dir.Aus);
        }
        ft.SetLamp(lamLichtschranken, Dir.Aus);
        ft.Pause(cPauseSek);
 
        lblStatus.Text = "Magazin : Vereinzeln";
        ft.SetLamp(lamLichtschranken, Dir.Ein);
        ft.Pause(cPauseSek);
        ft.WaitForInput(phoMagazin, false);
        ft.SetLamp(lamLichtschranken, Dir.Aus);
        ft.SetMotor(motKompressor, Dir.Links);
        ft.Pause(cPauseSek);
        ft.SetLamp(venSchieber, Dir.Ein);
        ft.Pause(cPauseSek);
        ft.SetLamp(venSchieber, Dir.Aus);
        ft.Pause(cPauseSek);

        lblStatus.Text = "Werkstück greifen";
        ft.SetLamp(venGreifer, Dir.Ein);
        ft.Pause(cPauseSek);
        ft.SetLamp(venVacuum, Dir.Ein);
        ft.Pause(cPauseSek);
        ft.SetLamp(venGreifer, Dir.Aus);
        ft.Pause(cPauseSek);
        ft.SetMotor(motKompressor, Dir.Aus);

        lblStatus.Text = "Verarbeitung an Position 2";
        ft.SetMotor(motDrehArm, Dir.Rechts);
        ft.Pause(300);
        ft.SetMotor(motDrehArm, Dir.Aus);
        ft.Pause(500);
        ft.SetMotor(motKompressor, Dir.Rechts);
        ft.Pause(cPauseSek);
        ft.SetLamp(venGreifer, Dir.Ein);
        ft.Pause(2000);
        ft.SetLamp(venGreifer, Dir.Aus);
        ft.Pause(cPauseSek);
        ft.SetMotor(motKompressor, Dir.Aus);

        lblStatus.Text = "Teil ablegen";
        ft.SetMotor(motDrehArm, Dir.Rechts);
        ft.Pause(300);
        ft.SetMotor(motDrehArm, Dir.Aus);
        ft.Pause(2000);
        ft.SetLamp(venVacuum, Dir.Aus);
      } while (!ft.Finish());
      ft.SetMotor(motKompressor, Dir.Aus);
    }

    #region --- Programm-Kontrolle ---
    public frmMain() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      // --- Open erstes ROBO an USB oder Intelligent Interface an COM
      //     während des Ablaufs von Action() gesperrt ---------------
      try {
        if (cboPortName.SelectedIndex == 0)
          ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        else ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

        ft.ClearMotors();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        ft.CloseInterface();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
    }

    private void formLoad(object sender, EventArgs e) {
      // --- Default-Interface : Erstes ROBO Interface an USB ----
      cboPortName.SelectedIndex = 0;
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}