﻿' -----------------------------------------------------------------------------------------
'
' VakuumGreifer4VB                                                 Ulrich Müller  07.09.08
'                                                                   Aspire  VB 2005 Express
' Template : Windows-Anwendungen auf Basis der Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class frmMain

	Dim ft As New FishFace()
	Const motKompressor As Out = Out.M1
	Const motDrehArm As Out = Out.M2
	Const venSchieber As Out = Out.O5
	Const venGreifer As Out = Out.O6
	Const venVacuum As Out = Out.O7
	Const lamLichtSchranken As Out = Out.O8
	Const phoDrehEnde As Inp = Inp.I1
	Const phoMagazin As Inp = Inp.I2

	Dim cPauseSek As Integer

	Sub Kompressor()
		ft.SetMotor(motKompressor, Dir.Rechts)
		ft.Pause(12000)
		ft.SetMotor(motKompressor, Dir.Aus)
	End Sub

	Private Sub Action()
		lblStatus.Text = "Kompressor : Druckaufbau"
		Kompressor()
		cPauseSek = numPause.Value
		Do
			ft.SetLamp(lamLichtSchranken, Dir.Ein)
			ft.Pause(cPauseSek)
			If ft.GetInput(phoDrehEnde) Then
				lblStatus.Text = "Zur Position am Magazin"
				ft.SetMotor(motDrehArm, Dir.Links)
				ft.WaitForInput(phoDrehEnde, False)
				ft.Pause(12)
				ft.SetMotor(motDrehArm, Dir.Aus)
			End If
			ft.SetLamp(lamLichtSchranken, Dir.Aus)
			ft.Pause(cPauseSek)

			lblStatus.Text = "Magazin : Vereinzeln"
			ft.SetLamp(lamLichtSchranken, Dir.Ein)
			ft.Pause(cPauseSek)
			ft.WaitForInput(phoMagazin, False)
			ft.SetLamp(lamLichtSchranken, Dir.Aus)
			ft.SetMotor(motKompressor, Dir.Links)
			ft.Pause(cPauseSek)
			ft.SetLamp(venSchieber, Dir.Ein)
			ft.Pause(cPauseSek)
			ft.SetLamp(venSchieber, Dir.Aus)
			ft.Pause(cPauseSek)

			lblStatus.Text = "Werkstück greifen"
			ft.SetLamp(venGreifer, Dir.Ein)
			ft.Pause(cPauseSek)
			ft.SetLamp(venVacuum, Dir.Ein)
			ft.Pause(cPauseSek)
			ft.SetLamp(venGreifer, Dir.Aus)
			ft.Pause(cPauseSek)
			ft.SetMotor(motKompressor, Dir.Aus)

			lblStatus.Text = "Verarbeitung an Position 2"
			ft.SetMotor(motDrehArm, Dir.Rechts)
			ft.Pause(300)
			ft.SetMotor(motDrehArm, Dir.Aus)
			ft.Pause(500)
			ft.SetMotor(motKompressor, Dir.Rechts)
			ft.Pause(cPauseSek)
			ft.SetLamp(venGreifer, Dir.Ein)
			ft.Pause(2000)
			ft.SetLamp(venGreifer, Dir.Aus)
			ft.Pause(cPauseSek)
			ft.SetMotor(motKompressor, Dir.Aus)

			lblStatus.Text = "Werkstück ablegen"
			ft.SetMotor(motDrehArm, Dir.Rechts)
			ft.Pause(300)
			ft.SetMotor(motDrehArm, Dir.Aus)
			ft.Pause(2000)
			ft.SetLamp(venVacuum, Dir.Aus)
		Loop Until ft.Finish()
		ft.SetMotor(motKompressor, Dir.Aus)
	End Sub

#Region "--- ProgramControl ---"
	Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
	Handles cmdAction.Click
		' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
		'     während des Ablaufs von Action gesperrt
		Try
			If cboPortName.SelectedIndex = 0 Then
				ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
			Else
				ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
			End If
			cmdAction.Enabled = False
			cmdEnde.Text = "&HALT"
			lblStatus.Text = "--- Bei der Arbeit ---"

			Action()					' --- Nutz-Routine für die Anwendung

			ft.ClearMotors()
		Catch ex As FishFaceException
			MsgBox(ex.Message)
		Finally
			ft.CloseInterface()
			cmdAction.Enabled = True
			cmdEnde.Text = "&ENDE"
			lblStatus.Text = "--- Auf ein Neues ---"
			cmdEnde.Focus()
		End Try

	End Sub

	Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
		' --- Programmende nur, wenn Action nicht läuft ---
		If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
	End Sub

	Private Sub frmLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		' --- Default erstes ROBO Interface an USB ---
		cboPortName.SelectedIndex = 0
	End Sub

	Private Sub frmClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
		' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
		If cmdEnde.Text = "&HALT" Then e.Cancel = True
	End Sub

#End Region
End Class
